let url = 'http://www.aryaanstudycirclehs.com/timings-of-the-day';
let table, classes;
let sundayRaw;
let storage = window.localStorage;

function getData(cb){
	let ret = null;
	let rawData = window.sessionStorage.getItem('savedHTML');
	if(rawData && rawData !== undefined){
        ret = `<div id="contents">${rawData}</div>`;
        cb(ret);
    }else{
        $.get(`https://cors-anywhere.herokuapp.com/${url}`, function(data){
            let body = $(data).find('#contents')[0];
            window.sessionStorage.setItem('savedHTML', $(body).html());
            ret = body;
            cb(ret);
        });
    }
}

function setup(contents) {
    contents = $(contents);

    table = contents.find('table');
    table = table.parsetable();
    table = table.map(col=> col.map(val=>{
        let p = $(val).find('span');
        let lines = [];
            p.map(function(){
                return lines.push($(this).text().replace(/<[^>]+>/g, ' ').trim());
            });
        return lines.join('#');
    }));

    //get class names
    classes = [];
    table.forEach((col, i)=>{
        if(i == 0) return;
        col.forEach((val, j)=>{
            if(j != 0) return;
            classes.push(val)
        });
    });
    sundayRaw = [];
    contents.find('table').remove();
    $(contents).find('p').each(function(i, elem){
        let text = $(this).text().trim();
        if(text.length > 2) sundayRaw.push(text);
    });
    sundayRaw = sundayRaw.join('~');
    let parts = sundayRaw.split(':');
    parts.shift();
    parts.forEach(line=>{
        if(line.indexOf('8th') > -1){ //foundation
            classes.push('8th, 9th, 10th Foundation');
        }
    });
    classes = classes.filter(function(item, pos) {
        return classes.indexOf(item) == pos;
    });
}

function loadClass(name){
    localStorage.setItem('lastClass', JSON.stringify(name));
    if(name == '8th, 9th, 10th Foundation'){
        $('#timingsContainer').append(`
            <div class="table-responsive">
                <table class="table table-bordered table-striped my-table">
                    <thead class="thead">
                        <tr>
                            <th class="p-3" scope="col">Date</th>
                            <th class="p-3" scope="col">Subject</th>
                        </tr>
                    </thead>
                    <tbody id="tableBody">
                    </tbody>
                </table>
            </div>
        `);
    }
    
    // $('#timingsContainer').append(`<h1>Timings For ${name}</h1>`)
    let extra = {'XI': {}, 'XII': {}};//eleven and twelve timetable in 8,9,10 section

    let object = [];
    let parts = sundayRaw.split('~');
    // log(parts);
    let indexes = [];
    parts.forEach((part, i)=>{
        if(part.match(/[0-9][0-9]\/[0-9][0-9]\/[0-9][0-9]/g)){
            indexes.push(i);
        }
    });
    indexes.push(parts.length-1);
    let days = [];
    for(let i = 0; i <= indexes.length-1; i++){
        let str = parts.slice(indexes[i], indexes[i+1]);
        let first = str[0];
        str.shift();        
        let pieces = first.split(':');
        let date = pieces[0];

        //--check if eleven and twelve timetable is present---
        
        let full = str.join('~');
        let eleven = full.match(/XI (.*)XII/g);
        if(eleven){
            eleven = eleven[0].split('~');
            eleven.pop();
            extra['XI'] = {
                date: date, 
                subject: eleven.join('<br>')
            }
        }
        let twelve = full.match(/XII(.*)/g);
        if(twelve){
            twelve = twelve[0].split('~');
            extra['XII'] = {
                date: date, 
                subject: twelve.join('<br>')
            }
        }

        //--------------------------------------------------
        if(pieces.length == 1){
            date = '';
        }else{
            pieces.shift();
        }
        
        str.unshift(pieces);
        days.push({date: date, subject: str});
        if(name == '8th, 9th, 10th Foundation'){
            $('#tableBody').append(`
                <tr>
                    <td class="my-table-element pl-3 pt-3 pb-2 spaced-line">${date}</td>
                    <td class="my-table-element pl-3 pt-3 pb-2 spaced-line">
                        <p>${str.join('<br><br>')}</p>
                    </td>
                </tr>
            `);
        }
    }
    if(name == '8th, 9th, 10th Foundation'){
        return;   
    }else{
        let tempTable = JSON.parse(JSON.stringify(table));
        let found = tempTable.filter(t=>{return t[0].replace(/<[^>]+>/g, '') == name})[0];
        
        console.log(found);

        let dates = tempTable[0];

        found.shift(); //shift is to remove the title name
        dates.shift(); //shift is to remove the title date

        let data = [];
        for(let i = 0; i < Math.max(found.length, dates.length); i++){
            data.push({
                date: dates[i].trim().replace(/  +/g, ' ').split('#').join('<br>'),
                subject: found[i].trim().replace(/<[^>]+>/g, '').replace('&#xA0;', '') === '' ? '' : found[i].replace('&#xA0;', '').split('#').join('<br>'),
            });
        }
        if(name.indexOf('XII') > -1 && extra['XII'].date && extra['XII'].subject){
            data.push({
                date: extra['XII'].date.split(' ').join('<br>'),
                subject: extra['XII'].subject,
            });
        }else if(name.indexOf('XI') > -1 && extra['XI'].date && extra['XI'].subject){
            data.push({
                date: extra['XI'].date.split(' ').join('<br>'),
                subject: extra['XI'].subject,
            });
        }
        $('#timingsContainer').append(`
            <table class="table table-bordered table-striped my-table">
                <thead class="thead">
                    <tr>
                        <th class="p-3" scope="col">Date</th>
                        <th class="p-3" scope="col">Subject</th>
                    </tr>
                </thead>
                <tbody id="table-body">
                </tbody>
            </table>
        `);

        data.forEach(({date, subject})=>{
            if(subject == '&nbsp;' || subject.length < 3){
                $('#table-body').append(`
                    <tr>
                        <td class="my-table-element no-class spaced-line">${date}</td>
                        <td class="my-table-element no-class">
                            <h4 class="mt-3 text text-success"><b>NO CLASS</b></h4>
                        </td>
                    </tr>
                `);

            }else{
                $('#table-body').append(`
                <tr>
                    <td class="my-table-element spaced-line">${date}</td>
                    <td class="my-table-element pl-3 pt-3 pb-2 spaced-line">
                        <p>${subject}</p>
                    </td>
                </tr>
            `); 
            }
            
        })

        
    }
}